/*
 * overwrite: overwrite the data in specified files to destroy
 * on-disk copy of confidential data.
 *
 * Copyright 2001 Bob Toxen.  All Rights Reserved.
 *
 * Purchasers of the book "Real World Linux Security --
 * Intrusion Prevention, Detection and Recovery" may copy this
 * script as needed to install and use on any system that they
 * administer.  Others may not copy or use it without obtaining
 * specific written permission by contacting the author at
 * book@cavu.com.
 *
 * Portions of the code may be incorporated into other programs
 * under these provisions, including the display of this
 * copyright and noting that it applies only to the code from
 * this program incorporated.
 *
 * Offered as is with no warranty of any kind.
 *
 * /usr/local/bin/overwrite: overwrite specified files
 * (possibly containing confidential data) to obliterate
 * data and if -r is supplied remove the files.
 */
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

#define	BSIZE	1024

int	rm;
char	buf[BSIZE];

erase(char *fname, int nuke)
{
	int	chunk;
	int	fd	= -1;
	struct	stat	sb;

	fd = open(fname, 1);
	if (fd < 0)
		goto oops;
	if (fstat(fd, &sb) < 0)
		goto oops;
	if (lseek(fd, 0, SEEK_SET) < 0)
		goto oops;
	while (sb.st_size > 0) {
		chunk = BSIZE;
			/*
			 * Carefully written to
			 * not overflow 32-bit
			 * signed arithmetic.
			 */
		if (sb.st_size < chunk)
			chunk = sb.st_size;
		if (write(fd, buf, chunk) != chunk)
			goto oops;
		sb.st_size -= chunk;
	}
	if (nuke)
		if (unlink(fname) < 0)
			goto oops;
	close(fd);
	return 0;

oops:
	perror(fname);
	if (fd >= 0)
		close(fd);
	return -1;
}

main(int argc, char **argv)
{
	argc--;
	argv++;

	if (argc > 0 && !strcmp(*argv, "-r")) {
		rm = 1;
		argc--;
		argv++;
	}

	while (argc > 0) {
		if (erase(*argv, rm) < 0) {
			fprintf(stderr,
			  "Could not overwrite '%s'\n",
			  *argv);
		}
		argc--;
		argv++;
	}
	exit(0);
}
