#!/bin/sh
# rmtbackup1
# Copyright 2001 Bob Toxen.  All rights reserved.
# book@cavu.com
# May be distributed under the GNU public license
#
# Backs up /home, /var/spool/mail, and /etc
# as relative paths onto remote system "central"
# and sends status email to joe@pentacorp.com.
#
# The v flag to tar may be removed to not list
# file names in the email.  The O flag causes
# the archive to be written to standard out.
#
# The email will include any error messages.
cd /
tar -czvO --atime-preserve --totals home var/spool/mail etc \
  | ssh -l joe central dd ibs=100k obs=100k of=/tmp/rmt0 \
  | Mail -s "Backup from `hostname`" joe@pentacorp.com
