/*
 * Copyright 2001 Bob Toxen.  All rights reserved.
 * This program may be used under the terms of the
 * GNU GENERAL PUBLIC LICENSE Version 2.
 *
 * Offered as is with no warranty of any kind.
 */
#include <stdio.h>
#include <string.h>

char	hex[] = "0123456789ABCDEF";

decode(int c1)
{
	int	c2;
	int	i1;
	int	i2;

	if (c1 == EOF || (c2=getchar()) == EOF) {
		printf("<incomplete %% sequence>\n");
		return EOF;
	}
	if (c1 < ' ' || c1 > 126) {
		printf(
		  "<non-printable first char \\%03o after %%>",
		  c1);
		return -2;
	}
	if (c2 < ' ' || c2 > 126) {
		printf(
		  "<non-printable second char \\%03o after %%%c>",
		  c2, c1);
		return -2;
	}
	i1 = strchr(hex, c1) - hex;
	i2 = strchr(hex, c2) - hex;
	if (i1 < 0 || i1 > 15 || i2 < 0 || i2 > 15)  {
		printf("<invalid %%%c%c sequence>", c1, c2);
		return -2;
	}
	return i1*16 + i2;
}

main()
{
	int	c;

	while ((c=getchar()) != EOF) {
		if (c == '%') {
			c = decode(getchar());
			if (c == EOF)
				break;
			if (c == -2)
				continue;
		}
		if (c >= ' ' && c < 127 || c == '\n' || c == '\t')
			putchar(c);
		else
			printf("\\%03o", c);
	}
	exit(0);
}
