/*
 * warn: invoke blockip to warn of attempted break-in and lock out
 *
 * Copyright 2001 Bob Toxen.  All Rights Reserved.
 *
 * Purchasers of the book "Real World Linux Security --
 * Intrusion Prevention, Detection and Recovery" may copy this
 * script as needed to install and use on any system that they
 * administer.  Others may not copy or use it without obtaining
 * specific written permission by contacting the author at
 * book@cavu.com.
 *
 * Offered as is with no warranty of any kind.
 *
 * Arguments we pass to /usr/local/secbin/blockip:
 *	1. TCP Wrappers' %h expanded (host name)
 *	2. TCP Wrappers' %a expanded (IP)
 *	3. TCP Wrappers' %d expanded (service)
 *	4. TCP Wrappers' %c expanded (user@sys)
 *	5. TCP Wrappers' %u expanded (user name, if known)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	BLOCKIP	"/usr/local/secbin/blockip"

const
char	valid[] = "abcdefghijklmnopqrstuvwxyz"
  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789._/";

char	*
fix(char *string, char *null)
{
	char	*s;

	if (!string)
		return null;
	string = strdup(string);
	if (!string)
		return "memerr";
	for (s=string; *s; s++)
		if (!strchr(valid, *s))
			*s =  '_';
	if (strlen(string) > 20)
		string[20] = '\0';
	return string;
}

/* Validate IP. */
char	*
chkip(char *string)
{
	char	*s;
	char	*s0;
	int	part;

	if (!string)
		goto bad;
	s = string;
	for (part=0; part<4; part++) {
		s0 = s;
		while (*s >= '0' && *s <= '9')
			s++;
		if (s - s0 < 1 || s - s0 > 3
		  || *s++ != "...\0"[part] || atoi(s0) > 255) {
			goto bad;
		}
	}
	return string;

bad:	return "255.255.255.255";
}

main(int argc, char **argv)
{
	char	*host	= fix(getenv("REMOTE_HOST"), "");
	char	*ip;
	char	*service;
	char	*s;

	if (argc <= 1)
		service = "missing";
	else
		service = fix(argv[1], "missing");
	ip = chkip(getenv("REMOTE_ADDR"));
	if (geteuid() || setuid(0) < 0) {
		fprintf(stderr, "Must be set-uid root\n");
		exit(-1);
	}
	execl(BLOCKIP, "blockip", host, ip, service, "", "", 0);
	exit(2);
}
